// Globals for Apple Classes
var gDoneButton;
var gInfoButton;
var gMyScrollArea;
var gMyScrollbar;

// Our globals
var gFeedUrl		= "feed://www.apertureforum.de/feed.php";
var gFeedUrlHttp	= "http://www.apertureforum.de/feed.php";
var gReq;
var gUpdateInterval	= null;

if (window.widget)
{
	widget.onhide = onhide;
	widget.onshow = onshow;
}

// While Dashboard is open, update the feed articles once every hour
function onshow()
{
	if (gUpdateInterval == null)
	{
		getFeedArticles();
		gUpdateInterval = setInterval("getFeedArticles();", 1000*60*60); // update feeds once an hour
	}
}

// Don't refresh articles while Dashboard is closed
function onhide()
{
	if (gUpdateInterval != null)
	{
		clearInterval(gUpdateInterval);
		gUpdateInterval = null;
	}
}

function setup()
{
	// initialise scroll bar
	gMyScrollbar  = new AppleVerticalScrollbar(document.getElementById("feedScrollbar"));
    gMyScrollArea = new AppleScrollArea(document.getElementById("feedItems"));
    gMyScrollArea.addScrollbar(gMyScrollbar);


	// initialise Apple buttons
	gDoneButton	= new AppleGlassButton(document.getElementById("doneButton"), "Fertig", hidePrefs);
	gInfoButton	= new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);
	
	document.getElementById('version').innerHTML = "v" + version();

	onshow();
}

function doSearch()
{
	var s = document.getElementById("s").value;
	if (s)
	{
		goWebsite("http://apertureforum.de/search.php?keywords=" + escape(s));
	}
}

function getFeedArticles()
{
	gReq = new XMLHttpRequest();
	
	gReq.onreadystatechange = getItems;
	gReq.open("GET", gFeedUrlHttp);
	gReq.send();
}

function getItems()
{
	if (gReq.readyState == 4)
	{
		if (gReq.status == 200)
		{
			var items		= gReq.responseXML.getElementsByTagName("entry");
			var output		= "";
			var css			= new Array("itemDark", "itemLight");
			var cssflip		= 0;
			var maxItems	= 15;
			
			for (i = 0; i < items.length && i < maxItems; i++)
			{
				var title = findChild(items[i], "title").firstChild.data;
				var link = findChild(items[i], "link").getAttribute('href');
				
				output = output + '<div class="' + css[cssflip] + "\"><a href=\"#\" onclick=\"goWebsite('" + link + "');\">" + title +  '</a></div>';
				
				cssflip = ++cssflip % 2; // toggle cssflip
			}
			document.getElementById("feedItems").innerHTML = output;
			gMyScrollArea.refresh();			
		}
	}
}

// ----- BACK OF WIDGET STUFF -----

function goWebsite(url)
{
	if (window.widget)
		widget.openURL(url);
	else
		window.location = url;
}

// ----- STANDARD WIDGET STUFF -----

function showPrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function findChild (element, nodeName)
{
	var child;
	
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
		if (child.nodeName == nodeName)
			return child;
	}
	
	return null;
}

// version function courtesy of Joshua Emmons (www.skia.net)
function version()
{
    var xmlReq  = new XMLHttpRequest();
    xmlReq.open("GET", "Info.plist", false);
    xmlReq.send(null);

    var xml     = xmlReq.responseXML;
    var keys    = xml.getElementsByTagName("key");
    var ver     = "0.0";

    for(i = 0; i < keys.length; i++)
    {
        if("CFBundleVersion" == keys[i].firstChild.data)
        {
            ver = keys[i].nextSibling.nextSibling.firstChild.data;
            break;
        }
    }
    return ver;
}

